; ***********************************************************
function unpad, feld, w
; ***********************************************************

; Field size
a=size(feld)
if a[0] gt 3 then begin
  print, "Field dimensions too high. Aborting"
  return, 0
endif

if n_elements(w) ne 2*a[0] then begin
  print, "Boundaries do not match all edges"
  return, 0
endif
; new field size
for i=1,a[0] do a[i]=a[i]-w[2*i-2]-w[2*i-1]

if a[0] eq 1 then newfeld=feld[w[0]:w[0]+a[1]-1] $
else if a[0] eq 2 then newfeld=feld[w[0]:w[0]+a[1]-1,w[2]:w[2]+a[2]-1] $
else newfeld=feld[w[0]:w[0]+a[1]-1,w[2]:w[2]+a[2]-1,w[4]:w[4]+a[3]-1]

return, newfeld
end

; ***********************************************************
function zeropad, feld, width
; ***********************************************************

; Field size
a=size(feld)
if a[0] gt 3 then begin
  print, "Field dimensions too high. Aborting"
  return, 0
endif
; new array
newa=a

; if we have the right dimensions keep them
if n_elements(width) lt 2*a[0] then begin
  width=replicate(width,2*a[0])
  ; adjust field sizes so that parallelization can work
  for i=0,a[0]-1 do begin
    minwidth=a[i+1]+width[2*i]+width[2*i+1]
    powertwo=floor(alog(minwidth-1)/alog(2.0))
    choices=[5*2^(powertwo-2), 3*2^(powertwo-1), 2^(powertwo+1)]
    newa[i+1]=choices[min(where(minwidth le choices))]
    width[2*i]=(newa[i+1]-a[i+1])/2
    width[2*i+1]=newa[i+1]-a[i+1]-width[2*i]
  endfor
endif else begin
  for i=0,a[0]-1 do newa[i+1]=a[i+1]+width[2*i]+width[2*i+1]
endelse

; create larger field
newfeld=make_array(size=newa,value=0.0d0)

if a[0] eq 1 then newfeld[width[0]:width[0]+a[1]-1]=feld $
else if a[0] eq 2 then newfeld[width[0]:width[0]+a[1]-1,width[2]:width[2]+a[2]-1]=feld $
else newfeld[width[0]:width[0]+a[1]-1,width[2]:width[2]+a[2]-1,width[4]:width[4]+a[3]-1]=feld

return, newfeld
end

